Now compatible with Mistlands!

This mod **greatly improves multiplayer performance.** If you find this mod works as advertised, please endorse it!

**Default settings should be fine for most people.**

_Keep in mind_

* Compression only works between computers with Better Networking.
* Likely incompatible with (and better than) other networking mods.
* Dedicated servers will not apply changes until restarted.
* You must use the join code or *external* IP when connecting to servers on the same network when using crossplay.

_Features_

* crossplay enabled: improves compression speed (55x faster) and compression ratio
* crossplay disabled: adds network compression
* new connection buffer (AKA "ZDO buffer", prevents data loss)
* change outgoing queue size
* change outgoing update rate
* change min/max send rates in Steamworks (AKA crossplay disabled)
* dedicated servers: ability to enable/disable crossplay through Better Networking
* compatible with Linux
* compatible with players not running the mod

_Better Networking links_

* Please [provide feedback!](https://www.nexusmods.com/valheim/mods/1570?tab=posts)
* Please [report bugs!](https://www.nexusmods.com/valheim/mods/1570?tab=bugs)
* Please [endorse on Nexus Mods!](https://www.nexusmods.com/valheim/mods/1570)
* Please [endorse on ThunderStore!](https://valheim.thunderstore.io/package/CW_Jesse/BetterNetworking_Valheim/)

_Educational links_

* [Technical explanation of Valheim's networking](https://redd.it/mga1iw) by u/SleepMyLittleOnes
* [Technical information and discussions on desync/lag in Valheim](https://jamesachambers.com/revisiting-fixing-valheim-lag-modifying-send-receive-limits/) on the blog of James A. Chambers

_Thank you_

* nightshade221 (Max) for being a patron and providing a community!
* Frostsorrow for QA and community assistance!
* Tquilarius for being a patron!
* Tatsuya009, Alexander3054, Dskaggsgv, vi0lation, Ersan191, WhiteDingoX5, xdhara, ImpulsiveMind, nevcairiel, ErDu, and doubletroubleswtor for valuable feedback and troubleshooting!
* [Oleg Stepanischev](https://github.com/oleg-st) for [ZstdSharp](https://github.com/oleg-st/ZstdSharp)
* [Smoothbrain](https://valheim.thunderstore.io/package/Smoothbrain/) for [Network](https://valheim.thunderstore.io/package/Smoothbrain/Network/)

**If you've benefited from this mod and want to see more features implemented, please endorse it! Or if you're feeling particularly generous, donate here or [on Patreon](https://www.patreon.com/CW_Jesse)!**